#!/bin/sh
# (C) 2002 Vladimir Ivaschenko <vi@maks.net>, licensed under GPL2

tmpfile=`mktemp /tmp/upload-wdistXXXXXX`

syntaxhelp() {
    echo "Usage:"
    echo
    echo "upload-wdist [remote host] [local directory with packages]"
    exit
}

REMHOST=$1
[ -z "$REMHOST" ] && syntaxhelp
LOCALDIR=$2 || LOCALDIR="./"

rm -f $tmpfile
echo "Checking if remote is running upgrade-wdist ... "
scp $REMHOST:/tmp/_upgradewdist-auto $tmpfile
echo
if [ ! -f $tmpfile ] ; then
    echo "Upgrade procedure is not running on the remote system! Exiting."
    exit
fi

clear
echo "Please note that this script requires that you setup SSH RSA keys "
echo "authentication between your host and remote machine. Another"
echo "option is to empty the password of the user you're connecting (not"
echo "recommended)."
echo ""
echo "In any other case you'll be always asked for password."
echo

while [ -z "$FINISHED" ] ; do
    echo -n -e "\r[`date`] Waiting for command from remote ...      "
    rm -f $tmpfile
    scp $REMHOST:/tmp/_upgradewdist-waiting4-lrp $tmpfile >/dev/null 2>/dev/null
    if [ -f $tmpfile ] && [ -z "$INSTALLED_LRP" ] ; then
	echo
	echo "Copying LRP packages to remote... "
	scp $LOCALDIR/*.lrp $REMHOST:/var/lib/lrpkg/mnt/
	touch $tmpfile
	scp $tmpfile $REMHOST:/tmp/_upgradewdist-lrp-uploaded >/dev/null 2>/dev/null
	rm -f $tmpfile
	echo
	echo "Done."
	echo
	INSTALLED_LRP=1
    fi
    rm -f $tmpfile
    scp $REMHOST:/tmp/_upgradewdist-waiting4-cfs $tmpfile >/dev/null 2>/dev/null
    if [ -f $tmpfile ] && [ -z "$INSTALLED_CFS" ] ; then
	echo
	echo "Copying CFS packages to remote... "
	scp $LOCALDIR/*.cfs $REMHOST:/var/lib/lrpkg/mnt/
	scp $LOCALDIR/*.md5 $REMHOST:/var/lib/lrpkg/mnt/
	touch $tmpfile
	scp $tmpfile $REMHOST:/tmp/_upgradewdist-cfs-uploaded
	rm -f $tmpfile
	echo
	echo "Done."
	echo
	
	INSTALLED_CFS=1
	FINISHED=1
	echo "Finished!"
	exit
    fi
    sleep 5
done

rm -f $tmpfile
    